## mingw-w64-paraview-5.13.1-3.src.tar.zst

=== Plugins/CFSReader/CMakeLists.txt ===
paraview_add_plugin(CFSReader
  REQUIRED_ON_SERVER
  VERSION "22.04"
  MODULES CFSReader::Reader
  MODULE_FILES "${CMAKE_CURRENT_SOURCE_DIR}/Reader/vtk.module")

if (BUILD_TESTING)
  add_subdirectory(Testing)
endif ()

=== Plugins/LegacyGhostCellsGenerator/CMakeLists.txt ===
set(modules
  LegacyGhostCellsGeneratorFilters)

set(module_files
  "${CMAKE_CURRENT_SOURCE_DIR}/Filters/vtk.module")

if (TARGET VTK::ParallelMPI)
  list(APPEND modules
    LegacyGhostCellsGeneratorParallel)
  list(APPEND module_files
    "${CMAKE_CURRENT_SOURCE_DIR}/Parallel/vtk.module")

endif()

paraview_add_plugin(LegacyGhostCellsGenerator
  REQUIRED_ON_CLIENT
  REQUIRED_ON_SERVER
  VERSION "1.0"
  MODULES ${modules}
  MODULE_FILES ${module_files})

if (BUILD_TESTING)
  add_subdirectory(Testing)
endif ()

=== Remoting/Core/CMakeLists.txt ===
# SPDX-FileCopyrightText: Copyright (c) Kitware Inc.
# SPDX-FileCopyrightText: Copyright (c) Sandia Corporation
# SPDX-License-Identifier: BSD-3-Clause
set(classes
  vtkCompositeMultiProcessController
  vtkDisplayConfiguration
  vtkMPIMToNSocketConnection
  vtkMPIMToNSocketConnectionPortInformation
  vtkNetworkAccessManager
  vtkPResourceFileLocator
  vtkProcessModule
  vtkProcessModuleConfiguration
  vtkPVAlgorithmPortsInformation
  vtkPVArrayInformation
  vtkPVClassNameInformation
  vtkPVDataAssemblyInformation
  vtkPVDataInformation
  vtkPVDataSetAttributesInformation
  vtkPVDataSizeInformation
  vtkPVDisableStackTraceSignalHandler
  vtkPVDynamicInitializerPluginInterface
  vtkPVEnableStackTraceSignalHandler
  vtkPVEnvironmentInformation
  vtkPVEnvironmentInformationHelper
  vtkPVFileInformation
  vtkPVFileInformationHelper
  vtkPVInformation
  vtkPVLogInformation
  vtkPVMemoryUseInformation
  vtkPVPlugin
  vtkPVPluginLoader
  vtkPVPluginsInformation
  vtkPVPluginTracker
  vtkPVProgressHandler
  vtkPVPythonInformation
  vtkPVPythonModule
  vtkPVPythonPluginInterface
  vtkPVServerInformation
  vtkPVServerManagerPluginInterface
  vtkPVSession
  vtkPVSystemConfigInformation
  vtkPVSystemInformation
  vtkPVTemporalDataInformation
  vtkPVTimerInformation
  vtkRemotingCoreConfiguration
  vtkSession
  vtkSessionIterator
  vtkTCPNetworkAccessManager)

set(sources)
set(private_headers
  vtkProcessModuleInternals.h)

set(headers
  vtkReservedRemoteObjectIds.h)
if (APPLE)
  list(APPEND sources
    vtkPVMacFileInformationHelper.mm)
  list(APPEND private_headers
    vtkPVMacFileInformationHelper.h)
endif ()

set(nowrap_headers)

set_property(SOURCE vtkPVPluginLoader.cxx APPEND
  PROPERTY
    COMPILE_DEFINITIONS "BUILD_SHARED_LIBS=$<BOOL:${BUILD_SHARED_LIBS}>")

if (WIN32)
  set(libdir_relpath ".")
else ()
  file(RELATIVE_PATH libdir_relpath
    "/prefix/${_vtk_build_RUNTIME_DESTINATION}"
    "/prefix/${_vtk_build_LIBRARY_DESTINATION}")
endif ()
set_property(SOURCE vtkPVPluginTracker.cxx APPEND
  PROPERTY
    COMPILE_DEFINITIONS
      "BUILD_SHARED_LIBS=$<BOOL:${BUILD_SHARED_LIBS}>"
      "PARAVIEW_RELATIVE_LIBPATH=\"${libdir_relpath}\""
      "PARAVIEW_SUBDIR=\"paraview${paraview_version_suffix}/plugins\"")

set(vtkProcessModule_defines "BUILD_SHARED_LIBS=$<BOOL:${BUILD_SHARED_LIBS}>")
if (PARAVIEW_INITIALIZE_MPI_ON_CLIENT)
  list(APPEND vtkProcessModule_defines
    PARAVIEW_INITIALIZE_MPI_ON_CLIENT)
endif ()
set_source_files_properties(vtkProcessModule.cxx
  PROPERTIES
    COMPILE_DEFINITIONS "${vtkProcessModule_defines}")

set_source_files_properties(vtkProcessModuleConfiguration.cxx
  PROPERTIES
    COMPILE_DEFINITIONS "PARAVIEW_USE_PYTHON=$<BOOL:${PARAVIEW_USE_PYTHON}>")

# TODO: Expose CMake options for these?
set(vtkPVOptions_defines)
if (PARAVIEW_ALWAYS_SECURE_CONNECTION)
  list(APPEND vtkPVOptions_defines
    PARAVIEW_ALWAYS_SECURE_CONNECTION)
endif ()
if (PARAVIEW_ENABLE_FPE)
  list(APPEND vtkPVOptions_defines
    PARAVIEW_ENABLE_FPE)
endif ()
if (VTK_OPENGL_HAS_EGL)
  list(APPEND vtkPVOptions_defines
    VTK_OPENGL_HAS_EGL)
endif ()
set_source_files_properties(vtkPVOptions.cxx
  PROPERTIES
    COMPILE_DEFINITIONS "${vtkPVOptions_defines}")

set(PARAVIEW_PLUGIN_LOADER_PATHS ""
  CACHE STRING "Extra paths to search for plugins")
mark_as_advanced(PARAVIEW_PLUGIN_LOADER_PATHS)
if (PARAVIEW_PLUGIN_LOADER_PATHS)
  set_source_files_properties(vtkPVPluginLoader.cxx
    PROPERTIES
      COMPILE_DEFINITIONS PARAVIEW_PLUGIN_LOADER_PATHS=\"${PARAVIEW_PLUGIN_LOADER_PATHS}\")
endif ()

if (NOT PARAVIEW_BUILD_LEGACY_REMOVE)
  # Based on state of VTK modules, set up some variables that paraview needs to
  # compile optional code.
  configure_file(
    "${CMAKE_CURRENT_SOURCE_DIR}/vtkPVConfig.h.in"
    "${CMAKE_CURRENT_BINARY_DIR}/vtkPVConfig.h"
    @ONLY)
  list(APPEND nowrap_headers
    "${CMAKE_CURRENT_BINARY_DIR}/vtkPVConfig.h")
endif ()

vtk_module_add_module(ParaView::RemotingCore
  CLASSES ${classes}
  SOURCES ${sources}
  HEADERS ${headers}
  NOWRAP_HEADERS ${nowrap_headers}
  PRIVATE_HEADERS ${private_headers})

# for vtkPVFileInformation
if (WIN32)
  vtk_module_link(ParaView::RemotingCore
    PRIVATE
      mpr)
elseif (APPLE)
  vtk_module_link(ParaView::RemotingCore PUBLIC "-framework Foundation")
endif ()

=== Clients/ParaView/Testing/CMakeLists.txt ===
option(PARAVIEW_CLIENT_RENDER_SERVER_TESTS
  "Turn on/off client tests that involve separate data and render servers."
  ON)
mark_as_advanced(PARAVIEW_CLIENT_RENDER_SERVER_TESTS)

# Set these to make the testing macros work properly.
set(_vtk_build_TEST_OUTPUT_DATA_DIRECTORY "${paraview_test_data_directory_output}")
set(_vtk_build_TEST_OUTPUT_DIRECTORY "${CMAKE_BINARY_DIR}/Testing/Temporary")
set(_vtk_build_TEST_DATA_TARGET "ParaViewData")
set(PARAVIEW_TEST_BASELINE_DIR "${CMAKE_CURRENT_SOURCE_DIR}/Data/Baseline")

add_subdirectory(XML)
if (PARAVIEW_USE_PYTHON)
  add_subdirectory(Python)
endif ()

=== Plugins/DSP/Filters/CMakeLists.txt ===
set(MODULE_CLASSES
  vtkBandFiltering
  vtkDSPTableFFT
  vtkMeanPowerSpectralDensity
  vtkMergeReduceTables
  vtkMultiDimensionBrowser
  vtkProjectSpectrumMagnitude
  vtkSoundQuantitiesCalculator
  vtkSpectrogramFilter
  vtkTemporalMultiplexing
)

set(MODULE_HEADERS
  vtkAccousticUtilities.h
)

vtk_module_add_module(DigitalSignalProcessing::DSPFiltersPlugin
  FORCE_STATIC  # build static library, to avoid confusion when loading
  CLASSES         ${MODULE_CLASSES}
  PRIVATE_CLASSES ${MODULE_PRIVATE_CLASSES}
  HEADERS         ${MODULE_HEADERS}
)

paraview_add_server_manager_xmls(
  XMLS  DSPFilters.xml)

=== Plugins/EmbossingRepresentations/Representations/CMakeLists.txt ===
set(classes
  vtkBumpMapMapper
  vtkBumpMapRepresentation
  vtkOpenGLBumpMapMapperDelegator
  vtkOpenGLExtrusionMapperDelegator
  vtkExtrusionMapper
  vtkExtrusionRepresentation)

set(shaders
  shaders/vtkExtrudeCell_gs.glsl)
set(sources)
set(private_headers)

foreach (shader IN LISTS shaders)
  vtk_encode_string(
    INPUT "${shader}"
    HEADER_OUTPUT shader_header
    SOURCE_OUTPUT shader_source)
  list(APPEND private_headers
    "${shader_header}")
  list(APPEND sources
    "${shader_source}")
endforeach ()

vtk_module_add_module(EmbossingRepresentations::vtkEmbossingRepresentations
  CLASSES ${classes}
  SOURCES ${sources}
  PRIVATE_HEADERS ${private_headers})

paraview_add_server_manager_xmls(
  XMLS  EmbossingRepresentations.xml)
vtk_module_definitions(EmbossingRepresentations::vtkEmbossingRepresentations PRIVATE QT_NO_KEYWORDS)

=== Plugins/GmshReader/Reader/CMakeLists.txt ===
set(classes
  vtkGmshMetaReader
  vtkGmshReader)

set(private_headers
  vtkGmshIncludes.h)

vtk_module_find_package(
  PACKAGE Gmsh
  VERSION 4.1.0)

vtk_module_add_module(GmshReader::vtkGmshReader
  CLASSES ${classes}
  PRIVATE_HEADERS ${private_headers})
vtk_module_link(GmshReader::vtkGmshReader
  PRIVATE
    Gmsh::Gmsh)

paraview_add_server_manager_xmls(
  XMLS  GmshReaderServerManager.xml)

=== VTK/Common/Core/CMakeLists.txt ===
include(CMakeDependentOption)
cmake_dependent_option(VTK_USE_64BIT_TIMESTAMPS "Build VTK with 64 bit timestamps" OFF
  "NOT CMAKE_SIZEOF_VOID_P GREATER 4" ON)
mark_as_advanced(VTK_USE_64BIT_TIMESTAMPS)

# Option to mangle VTK symbols
set(VTK_ABI_NAMESPACE_NAME
  "<DEFAULT>"
  CACHE STRING "Inline namespace name for mangling VTK symbols.")
mark_as_advanced(VTK_ABI_NAMESPACE_NAME)
set(VTK_ABI_NAMESPACE_ATTRIBUTES
  "<DEFAULT>"
  CACHE STRING "Inline namespace attributes for mangling VTK symbols.")
mark_as_advanced(VTK_ABI_NAMESPACE_ATTRIBUTES)

if (VTK_ABI_NAMESPACE_NAME STREQUAL "<DEFAULT>")
  # The default is to not have an ABI namespace.
  # This is consistent with the existing practice.
  set(VTK_ABI_NAMESPACE_NAME "")
endif ()
set_property(GLOBAL PROPERTY _vtk_abi_namespace_name "${VTK_ABI_NAMESPACE_NAME}")

if (VTK_ABI_NAMESPACE_ATTRIBUTES STREQUAL "<DEFAULT>")
  set(VTK_ABI_NAMESPACE_ATTRIBUTES "")
endif()
set_property(GLOBAL PROPERTY _vtk_abi_namespace_attributes "${VTK_ABI_NAMESPACE_ATTRIBUTES}")

if (VTK_ABI_NAMESPACE_NAME STREQUAL "")
  set(VTK_HAS_ABI_NAMESPACE OFF)
  set(VTK_ABI_NAMESPACE_BEGIN "")
  set(VTK_ABI_NAMESPACE_END "")
else ()
  message(STATUS "VTK ABI namespace: ${VTK_ABI_NAMESPACE_NAME}")
  set(_vtk_abi_namespace_name_regex "^[a-zA-Z0-9_]+$")
  if (NOT VTK_ABI_NAMESPACE_NAME MATCHES "${_vtk_abi_namespace_name_regex}")
    message(FATAL_ERROR
      "The configured VTK_ABI_NAMESPACE_NAME='${VTK_ABI_NAMESPACE_NAME}' is "
      "not supported, it must match the regular expression "
      "'${_vtk_abi_namespace_name_regex}'.  To add things like attributes, "
      "configure VTK with -DVTK_ABI_NAMESPACE_ATTRIBUTES='"
      "__attribute__((visibility(\"hidden\")))'.")
  endif()
  unset(_vtk_abi_namespace_name_regex)
  set(VTK_HAS_ABI_NAMESPACE ON)
  set(VTK_ABI_NAMESPACE_BEGIN "inline namespace ${VTK_ABI_NAMESPACE_ATTRIBUTES} ${VTK_ABI_NAMESPACE_NAME} {")
  set(VTK_ABI_NAMESPACE_END "}")
endif ()

if (VTK_ABI_NAMESPACE_ATTRIBUTES STREQUAL "")
  set(VTK_HAS_ABI_NAMESPACE_ATTRIBUTES OFF)
else ()
  set(VTK_HAS_ABI_NAMESPACE_ATTRIBUTES ON)
endif ()

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkABINamespace.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkABINamespace.h"
  @ONLY)

if (CMAKE_SIZEOF_VOID_P GREATER 4)
 set(vtk_use_64bit_ids_default ON)
else ()
 set(vtk_use_64bit_ids_default OFF)
endif ()

option(VTK_USE_64BIT_IDS "Build VTK with 64 bit ids" "${vtk_use_64bit_ids_default}")
mark_as_advanced(VTK_USE_64BIT_IDS)

option(VTK_USE_FUTURE_CONST "Adds more const to APIs. Opt-in because it may break compatibility" OFF)
mark_as_advanced(VTK_USE_FUTURE_CONST)

option(VTK_USE_FUTURE_BOOL "Changes some ints to bools. Opt-in because it may break compatibility" OFF)
mark_as_advanced(VTK_USE_FUTURE_BOOL)

option(VTK_DEBUG_LEAKS "Build leak checking support into VTK." OFF)
mark_as_advanced(VTK_DEBUG_LEAKS)

# See vtkDataArrayRange.h docs for more info on these:
cmake_dependent_option(VTK_DEBUG_RANGE_ITERATORS
  "Detect usage errors with the for-range iterators (SLOW)." OFF
  "CMAKE_BUILD_TYPE STREQUAL \"Debug\"" OFF)
mark_as_advanced(VTK_DEBUG_RANGE_ITERATORS)
cmake_dependent_option(VTK_ALWAYS_OPTIMIZE_ARRAY_ITERATORS
  "Enable additional optimizations for array iterators in Debug builds." OFF
  "NOT VTK_DEBUG_RANGE_ITERATORS" OFF)
mark_as_advanced(VTK_ALWAYS_OPTIMIZE_ARRAY_ITERATORS)

# This option determines the behavior of the New methods of vtkObject derived
# classes. If this option is off then only classes specifically using the
# vtkObjectFactoryNewMacro and vtkAbstractObjectFactoryNewMacro will allow for
# overrides. If the method is on then vtkStandardNewMacro will use the
# vtkObjectFactoryNewMacro's implementation body.
option(VTK_ALL_NEW_OBJECT_FACTORY
  "Build all vtkObject derived classes with object factory new methods." OFF)
mark_as_advanced(VTK_ALL_NEW_OBJECT_FACTORY)

set(vtk_smp_sources)
set(vtk_smp_headers)
set(vtk_smp_nowrap_headers)
set(vtk_smp_templates)
set(vtk_smp_defines)
set(vtk_smp_libraries)
set(vtk_smp_enable_sequential 0)
set(vtk_smp_enable_stdthread 0)
set(vtk_smp_enable_tbb 0)
set(vtk_smp_enable_openmp 0)
set(VTK_SMP_IMPLEMENTATION_TYPE)
include("${CMAKE_CURRENT_SOURCE_DIR}/vtkSMPSelection.cmake")

set(vtk_object_base_defines)

# An optional dependency on memkind
set(vtk_memkind_libraries)
if (VTK_USE_MEMKIND)
  vtk_module_find_package(
    PACKAGE MEMKIND)
  list(APPEND vtk_memkind_libraries
    MEMKIND::MEMKIND)
  # XXX(memkind-1.10): Once 1.10 is required, this is always true.
  file(READ "${MEMKIND_INCLUDE_DIR}/memkind.h" memkind_h_contents)
  set(memkind_has_dax_kmem 0)
  # Look for the symbol in the header.
  if (memkind_h_contents MATCHES " MEMKIND_DAX_KMEM[ ;\n]")
    set(memkind_has_dax_kmem 1)
  endif ()
  list(APPEND vtk_object_base_defines "VTK_MEMKIND_HAS_DAX_KMEM=$<BOOL:${memkind_has_dax_kmem}>")
endif ()

# Generate the vtkTypeList_Create macros:
include("${CMAKE_CURRENT_SOURCE_DIR}/vtkCreateTypeListMacros.cmake")
CreateTypeListMacros(
  VTK_TYPELISTMACRO_HEADER_CONTENTS
  99
  vtkTypeList_Create
  "vtkTypeList::TypeList"
  "vtkTypeList::NullType")
configure_file(vtkTypeListMacros.h.in vtkTypeListMacros.h)

# And the ArrayDispatch array list header:
option(VTK_DISPATCH_AOS_ARRAYS "Include array-of-structs vtkDataArray subclasses in dispatcher." ON)
option(VTK_DISPATCH_SOA_ARRAYS "Include struct-of-arrays vtkDataArray subclasses in dispatcher." OFF)
option(VTK_DISPATCH_TYPED_ARRAYS "Include vtkTypedDataArray subclasses (e.g. old mapped arrays) in dispatcher." OFF)

option(VTK_DISPATCH_AFFINE_ARRAYS "Include implicit vtkDataArray subclasses based on an affine function backend in dispatcher" OFF)
option(VTK_DISPATCH_CONSTANT_ARRAYS "Include implicit vtkDataArray subclasses based on a constant backend in dispatcher" OFF)
option(VTK_DISPATCH_STD_FUNCTION_ARRAYS "Include implicit vtkDataArray subclasses based on std::function in dispatcher" OFF)
option(VTK_DISPATCH_STRUCTURED_POINT_ARRAYS "Include implicit vtkDataArray subclasses based on structured point backend dispatcher" ON)

option(VTK_WARN_ON_DISPATCH_FAILURE "If enabled, vtkArrayDispatch will print a warning when a dispatch fails." OFF)

mark_as_advanced(
  VTK_DISPATCH_AOS_ARRAYS
  VTK_DISPATCH_SOA_ARRAYS
  VTK_DISPATCH_TYPED_ARRAYS

  VTK_DISPATCH_AFFINE_ARRAYS
  VTK_DISPATCH_CONSTANT_ARRAYS
  VTK_DISPATCH_STD_FUNCTION_ARRAYS
  VTK_DISPATCH_STRUCTURED_POINT_ARRAYS

  VTK_WARN_ON_DISPATCH_FAILURE)

option(VTK_BUILD_SCALED_SOA_ARRAYS "Include struct-of-arrays with scaled vtkDataArray implementation." OFF)

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkVTK_DISPATCH_IMPLICIT_ARRAYS.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkVTK_DISPATCH_IMPLICIT_ARRAYS.h"
  @ONLY)

include("${CMAKE_CURRENT_SOURCE_DIR}/vtkCreateArrayDispatchArrayList.cmake")
vtkArrayDispatch_default_array_setup()
vtkArrayDispatch_generate_array_header(VTK_ARRAYDISPATCH_ARRAY_LIST)
configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/vtkArrayDispatchArrayList.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/vtkArrayDispatchArrayList.h"
  @ONLY)

# create a list of source files for explicit array type instantiations
set(instantiation_sources)

include(vtkTypeLists)

foreach (INSTANTIATION_VALUE_TYPE IN LISTS vtk_numeric_types)
  # only instantiate fundamental types, not typedefs
  if (INSTANTIATION_VALUE_TYPE STREQUAL "vtkIdType")
    continue()
  endif ()
  # create a file suffix from the type
  string(REPLACE " " "_" _suffix "${INSTANTIATION_VALUE_TYPE}")

  set(_list
    vtkAffineArrayInstantiate
    vtkAffineImplicitBackendInstantiate
    vtkCompositeArrayInstantiate
    vtkCompositeImplicitBackendInstantiate
    vtkConstantArrayInstantiate
    vtkConstantImplicitBackendInstantiate
    vtkIndexedArrayInstantiate
    vtkIndexedImplicitBackendInstantiate
    vtkSOADataArrayTemplateInstantiate
    vtkStdFunctionArrayInstantiate
    vtkStructuredPointBackendInstantiate
    vtkStructuredPointArrayInstantiate
    vtkTypedDataArrayInstantiate)
  if (VTK_BUILD_SCALED_SOA_ARRAYS)
    list(APPEND _list "vtkScaledSOADataArrayTemplateInstantiate")
  endif ()

  # see comments in vtkGenericDataArray.h for explanation
  if (INSTANTIATION_VALUE_TYPE MATCHES "(^| )long( |$)")
    list(APPEND _list "vtkGenericDataArrayValueRangeInstantiate")
  endif ()

  # generate cxx file to instantiate template with this type
  foreach (_prefix IN LISTS _list)
    configure_file(
      "${CMAKE_CURRENT_SOURCE_DIR}/${_prefix}.cxx.in"
      "${CMAKE_CURRENT_BINARY_DIR}/${_prefix}_${_suffix}.cxx"
      @ONLY)
    list(APPEND instantiation_sources
      "${CMAKE_CURRENT_BINARY_DIR}/${_prefix}_${_suffix}.cxx")
  endforeach ()
endforeach ()

set(classes
  vtkAbstractArray
  vtkAnimationCue
  vtkArchiver
  vtkArray
  vtkArrayCoordinates
  vtkArrayExtents
  vtkArrayExtentsList
  vtkArrayIterator
  vtkArrayRange
  vtkArraySort
  vtkArrayWeights
  vtkAtomicMutex
  vtkBitArray
  vtkBitArrayIterator
  vtkBoxMuellerRandomSequence
  vtkBreakPoint
  vtkByteSwap
  vtkCallbackCommand
  vtkCharArray
  vtkCollection
  vtkCollectionIterator
  vtkCommand
  vtkCommonInformationKeyManager
  vtkDataArray
  vtkDataArrayCollection
  vtkDataArrayCollectionIterator
  vtkDataArraySelection
  vtkDebugLeaks
  vtkDebugLeaksManager
  vtkDeserializer
  vtkDoubleArray
  vtkDynamicLoader
  vtkEventForwarderCommand
  vtkFileOutputWindow
  vtkFloatArray
  vtkFloatingPointExceptions
  vtkGarbageCollector
  vtkGarbageCollectorManager
  vtkGaussianRandomSequence
  vtkIdList
  vtkIdListCollection
  vtkIdTypeArray
  vtkIndent
  vtkInformation
  vtkInformationDataObjectKey
  vtkInformationDoubleKey
  vtkInformationDoubleVectorKey
  vtkInformationIdTypeKey
  vtkInformationInformationKey
  vtkInformationInformationVectorKey
  vtkInformationIntegerKey
  vtkInformationIntegerPointerKey
  vtkInformationIntegerVectorKey
  vtkInformationIterator
  vtkInformationKey
  vtkInformationKeyLookup
  vtkInformationKeyVectorKey
  vtkInformationObjectBaseKey
  vtkInformationObjectBaseVectorKey
  vtkInformationRequestKey
  vtkInformationStringKey
  vtkInformationStringVectorKey
  vtkInformationUnsignedLongKey
  vtkInformationVariantKey
  vtkInformationVariantVectorKey
  vtkInformationVector
  vtkIntArray
  vtkLargeInteger
  vtkLogger
  vtkLongArray
  vtkLongLongArray
  vtkLookupTable
  vtkMath
  vtkMarshalContext
  vtkMersenneTwister
  vtkMinimalStandardRandomSequence
  vtkMultiThreader
  vtkNumberToString
  vtkOStrStreamWrapper
  vtkOStreamWrapper
  vtkObject
  vtkObjectBase
  vtkObjectFactory
  vtkObjectFactoryCollection
  vtkOldStyleCallbackCommand
  vtkOutputWindow
  vtkOverrideInformation
  vtkOverrideInformationCollection
  vtkPoints
  vtkPoints2D
  vtkPriorityQueue
  vtkRandomPool
  vtkRandomSequence
  vtkReferenceCount
  vtkSerializer
  vtkScalarsToColors
  vtkShortArray
  vtkSignedCharArray
  vtkSmartPointerBase
  vtkSortDataArray
  vtkStdString
  vtkStringArray
  vtkStringOutputWindow
  vtkStringToken
  vtkTimePointUtility
  vtkTimeStamp
  vtkUnsignedCharArray
  vtkUnsignedIntArray
  vtkUnsignedLongArray
  vtkUnsignedLongLongArray
  vtkUnsignedShortArray
  vtkVariant
  vtkVariantArray
  vtkVersion
  vtkVoidArray
  vtkWeakPointerBase
  vtkWeakReference
  vtkWindow
  vtkXMLFileOutputWindow)

set(template_classes
  vtkAOSDataArrayTemplate
  vtkArrayDispatch
  vtkArrayInterpolate
  vtkArrayIteratorTemplate
  vtkArrayPrint
  vtkDenseArray
  vtkGenericDataArray
  vtkMappedDataArray
  vtkSOADataArrayTemplate
  vtkSparseArray
  vtkTypedArray
  vtkTypedDataArray)

set(nowrap_template_classes
  vtkCompositeImplicitBackend
  vtkImplicitArray
  vtkIndexedImplicitBackend
  vtkStructuredPointBackend
  vtkTypeList)

# Hand written (de)serialization routines
set(serialization_helper_sources)
if (VTK_WRAP_SERIALIZATION)
  list(APPEND serialization_helper_sources
    vtkDataArraySerDesHelper.cxx
    vtkStringArraySerDesHelper.cxx)
endif ()

set(sources
  vtkArrayIteratorTemplateInstantiate.cxx
  vtkGenericDataArray.cxx
  vtkValueFromString.cxx

  vtkDataArray_CopyComponent.cxx
  vtkDataArray_DeepCopy.cxx

=== VTK/Rendering/VolumeOpenGL2/CMakeLists.txt ===
set(classes
  vtkMultiBlockUnstructuredGridVolumeMapper
  vtkMultiBlockVolumeMapper
  vtkOpenGLGPUVolumeRayCastMapper
  vtkOpenGLProjectedTetrahedraMapper
  vtkOpenGLRayCastImageDisplayHelper
  vtkSmartVolumeMapper
  vtkVolumeTexture)

set(nowrap_classes
  vtkOpenGLVolumeGradientOpacityTable
  vtkOpenGLVolumeLookupTable
  vtkOpenGLVolumeMaskGradientOpacityTransferFunction2D
  vtkOpenGLVolumeMaskTransferFunction2D
  vtkOpenGLVolumeOpacityTable
  vtkOpenGLVolumeRGBTable
  vtkOpenGLVolumeTransferFunction2D
  vtkVolumeInputHelper)

set(shader_files
  shaders/raycasterfs.glsl
  shaders/raycastervs.glsl
  shaders/vtkglProjectedTetrahedraFS.glsl
  shaders/vtkglProjectedTetrahedraVS.glsl)

set(nowrap_template_classes
  vtkOpenGLVolumeLookupTables
)

set(sources)
set(private_headers)
foreach (shader_file IN LISTS shader_files)
  vtk_encode_string(
    INPUT         "${shader_file}"
    EXPORT_HEADER "vtkRenderingVolumeOpenGL2Module.h"
    EXPORT_SYMBOL "VTKRENDERINGVOLUMEOPENGL2_NO_EXPORT"
    HEADER_OUTPUT header
    SOURCE_OUTPUT source)
  list(APPEND sources ${source})
  list(APPEND private_headers ${header})
endforeach ()

# Now for the object factory.
set(opengl_overrides
  GPUVolumeRayCastMapper
  ProjectedTetrahedraMapper
  RayCastImageDisplayHelper)

foreach (opengl_override IN LISTS opengl_overrides)
  vtk_object_factory_declare(
    BASE "vtk${opengl_override}"
    OVERRIDE "vtkOpenGL${opengl_override}")
endforeach ()

vtk_object_factory_configure(
  SOURCE_FILE vtk_object_factory_source
  HEADER_FILE vtk_object_factory_header
  EXPORT_MACRO "VTKRENDERINGVOLUMEOPENGL2_EXPORT")

vtk_module_add_module(VTK::RenderingVolumeOpenGL2
  CLASSES ${classes}
  NOWRAP_CLASSES ${nowrap_classes}
  NOWRAP_TEMPLATE_CLASSES  ${nowrap_template_classes}
  SOURCES ${sources} ${vtk_object_factory_source}
  PRIVATE_HEADERS ${private_headers} ${vtk_object_factory_header})
vtk_add_test_mangling(VTK::RenderingVolumeOpenGL2)

=== VTK/Filters/Temporal/Testing/CMakeLists.txt ===
vtk_module_test_data()

if (NOT vtk_testing_cxx_disabled)
  add_subdirectory(Cxx)
endif ()

if (VTK_WRAP_PYTHON)
  vtk_module_test_data(Data/cube-with-time.vtu)

  add_subdirectory(Python)
endif ()

=== VTK/ThirdParty/lzma/vtklzma/CMakeLists.txt ===
# liblzma wrapped for VTK by Quincy Wofford and John Patchett,
# Los Alamos National Laboratory (2017).
# Thanks to Lasse Collin for integration help

if (FALSE) # XXX(kitware): hide subprojects.
project(LZMA VERSION 5.2.5 LANGUAGES C)
set(CPACK_PACKAGE_DESCRIPTION_SUMMARY "LZMA compression library")
endif ()

# XXX(kitware): avoid quoted variable policy warning from CMake.
IF(CMAKE_C_COMPILER_ID STREQUAL "GNU" OR
   CMAKE_C_COMPILER_ID STREQUAL "Clang")
  SET(GNU_COMPATIBLE_COMPILER 1)
ENDIF()

include(TestBigEndian)
include(CheckIncludeFile)
include(CheckTypeSize)
include(ProcessorCount)

test_big_endian(WORDS_BIGENDIAN)

check_include_file("strings.h" HAVE_STRINGS_H)
check_include_file("byteswap.h" HAVE_BYTESWAP_H)
check_include_file("sys/endian.h" HAVE_SYS_ENDIAN_H)
if (HAVE_BYTESWAP_H)
  check_symbol_exists(HAVE_BSWAP_16 "byteswap.h" bswap_16)
  check_symbol_exists(HAVE_BSWAP_32 "byteswap.h" bswap_32)
  check_symbol_exists(HAVE_BSWAP_64 "byteswap.h" bswap_64)
endif ()

check_include_file("stdint.h" HAVE_STDINT_H)
check_include_file("inttypes.h" HAVE_INTTYPES_H)
check_include_file("limits.h" HAVE_LIMITS_H)
check_include_file("stdbool.h" HAVE_STDBOOL_H)
check_include_file("string.h" HAVE_STRING_H)
check_include_file("memory.h" HAVE_MEMORY_H)

check_type_size(int16_t INT16_T)
check_type_size(int32_t INT32_T)
check_type_size(int64_t INT64_T)
check_type_size(intmax_t INTMAX_T)
check_type_size(uint8_t UINT8_T)
check_type_size(uint16_t UINT16_T)
check_type_size(uint32_t UINT32_T)
check_type_size(uint64_t UINT64_T)
check_type_size(uintmax_t UINTMAX_T)

check_type_size("short" SIZE_OF_SHORT)
check_type_size("int" SIZE_OF_INT)
check_type_size("long" SIZE_OF_LONG)
check_type_size("long long" SIZE_OF_LONG_LONG)

check_type_size("unsigned short" SIZE_OF_UNSIGNED_SHORT)
check_type_size("unsigned" SIZE_OF_UNSIGNED)
check_type_size("unsigned long" SIZE_OF_UNSIGNED_LONG)
check_type_size("unsigned long long" SIZE_OF_UNSIGNED_LONG_LONG)
check_type_size("size_t" SIZE_OF_SIZE_T)

check_type_size("__int64" __INT64)
check_type_size("unsigned __int64" UNSIGNED___INT64)

check_type_size(uintptr_t UINTPTR_T)
IF(NOT HAVE_UINTPTR_T)
  IF("${CMAKE_SIZEOF_VOID_P}" EQUAL 8)
    SET(uintptr_t "uint64_t")
  ELSE()
    SET(uintptr_t "uint32_t")
  ENDIF()
ENDIF()

# We will need to add some encoder/decoder checking here
set(HAVE_DECODER_ARM 1)
set(HAVE_DECODER_ARMTHUMB 1)
set(HAVE_DECODER_DELTA 1)
set(HAVE_DECODER_IA64 1)
set(HAVE_DECODER_LZMA1 1)
set(HAVE_DECODER_LZMA2 1)
set(HAVE_DECODER_POWERPC 1)
set(HAVE_DECODER_SPARC 1)
set(HAVE_DECODER_X86 1)
set(HAVE_DECODERS 1)

set(HAVE_ENCODER_ARM 1)
set(HAVE_ENCODER_ARMTHUMB 1)
set(HAVE_ENCODER_DELTA 1)
set(HAVE_ENCODER_IA64 1)
set(HAVE_ENCODER_LZMA1 1)
set(HAVE_ENCODER_LZMA2 1)
set(HAVE_ENCODER_POWERPC 1)
set(HAVE_ENCODER_SPARC 1)
set(HAVE_ENCODER_X86 1)
set(HAVE_ENCODERS 1)

set(HAVE_MF_BT2 1)
set(HAVE_MF_BT3 1)
set(HAVE_MF_BT4 1)
set(HAVE_MF_HC3 1)
set(HAVE_MF_HC4 1)

# Define some checks
set(HAVE_CHECK_CRC32 1)
set(HAVE_CHECK_CRC64 1)
set(HAVE_CHECK_SHA256 1)
set(HAVE_DECODERS 1)

# Performance optimization
set(TUKLIB_FAST_UNALIGNED_ACCESS 1)
# Additional required mangling (var used by liblzma during build)
set(TUKLIB_SYMBOL_PREFIX vtklzma_)

find_package(Threads REQUIRED)
if (CMAKE_USE_WIN32_THREADS_INIT)
  set(MYTHREAD_VISTA 1)
elseif (CMAKE_USE_PTHREADS_INIT)
  set(MYTHREAD_POSIX 1)
else ()
  message(FATAL_ERROR
    "Unsupported threading backend for LZMA.")
endif ()

configure_file(
  "${CMAKE_CURRENT_SOURCE_DIR}/config.h.in"
  "${CMAKE_CURRENT_BINARY_DIR}/config.h")
add_definitions(-DHAVE_CONFIG_H)

include_directories(
  ${CMAKE_CURRENT_BINARY_DIR}
  ${CMAKE_CURRENT_SOURCE_DIR}/src
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/api
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma
  ${CMAKE_CURRENT_SOURCE_DIR}/src/common
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/check
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/common
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/lzma
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/lz
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/simple
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/delta
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/rangecoder
  ${CMAKE_CURRENT_SOURCE_DIR}/src/liblzma/common)

set(sources
  src/common/tuklib_cpucores.c
  src/common/tuklib_physmem.c
  src/liblzma/check/check.c
  src/liblzma/check/crc32_fast.c
  src/liblzma/check/crc32_table.c
  src/liblzma/check/crc64_fast.c
  src/liblzma/check/crc64_table.c
  src/liblzma/check/sha256.c
  src/liblzma/common/alone_decoder.c
  src/liblzma/common/alone_encoder.c
  src/liblzma/common/auto_decoder.c
  src/liblzma/common/block_buffer_decoder.c
  src/liblzma/common/block_buffer_encoder.c
  src/liblzma/common/block_decoder.c
  src/liblzma/common/block_encoder.c
  src/liblzma/common/block_header_decoder.c
  src/liblzma/common/block_header_encoder.c
  src/liblzma/common/block_util.c
  src/liblzma/common/common.c
  src/liblzma/common/easy_buffer_encoder.c
  src/liblzma/common/easy_decoder_memusage.c
  src/liblzma/common/easy_encoder.c
  src/liblzma/common/easy_encoder_memusage.c
  src/liblzma/common/easy_preset.c
  src/liblzma/common/filter_buffer_decoder.c
  src/liblzma/common/filter_buffer_encoder.c
  src/liblzma/common/filter_common.c
  src/liblzma/common/filter_decoder.c
  src/liblzma/common/filter_encoder.c
  src/liblzma/common/filter_flags_decoder.c
  src/liblzma/common/filter_flags_encoder.c
  src/liblzma/common/hardware_cputhreads.c
  src/liblzma/common/hardware_physmem.c
  src/liblzma/common/index.c
  src/liblzma/common/index_decoder.c
  src/liblzma/common/index_encoder.c
  src/liblzma/common/index_hash.c
  src/liblzma/common/outqueue.c
  src/liblzma/common/stream_buffer_decoder.c
  src/liblzma/common/stream_buffer_encoder.c
  src/liblzma/common/stream_decoder.c
  src/liblzma/common/stream_encoder.c
  src/liblzma/common/stream_encoder_mt.c
  src/liblzma/common/stream_flags_common.c
  src/liblzma/common/stream_flags_decoder.c
  src/liblzma/common/stream_flags_encoder.c
  src/liblzma/common/vli_decoder.c
  src/liblzma/common/vli_encoder.c
  src/liblzma/common/vli_size.c
  src/liblzma/delta/delta_common.c
  src/liblzma/delta/delta_decoder.c
  src/liblzma/delta/delta_encoder.c
  src/liblzma/lzma/fastpos_table.c
  src/liblzma/lzma/lzma2_decoder.c
  src/liblzma/lzma/lzma2_encoder.c
  src/liblzma/lzma/lzma_decoder.c
  src/liblzma/lzma/lzma_encoder.c
  src/liblzma/lzma/lzma_encoder_optimum_fast.c
  src/liblzma/lzma/lzma_encoder_optimum_normal.c
  src/liblzma/lzma/lzma_encoder_presets.c
  src/liblzma/lz/lz_decoder.c
  src/liblzma/lz/lz_encoder.c
  src/liblzma/lz/lz_encoder_mf.c
  src/liblzma/rangecoder/price_table.c
  src/liblzma/simple/arm.c
  src/liblzma/simple/armthumb.c
  src/liblzma/simple/ia64.c
  src/liblzma/simple/powerpc.c
  src/liblzma/simple/simple_coder.c
  src/liblzma/simple/simple_decoder.c
  src/liblzma/simple/simple_encoder.c
  src/liblzma/simple/sparc.c
  src/liblzma/simple/x86.c)

set(private_headers
  src/common/mythread.h
  src/common/sysdefs.h
  src/common/tuklib_common.h
  src/common/tuklib_config.h
  src/common/tuklib_cpucores.h
  src/common/tuklib_integer.h
  src/common/tuklib_physmem.h
  src/liblzma/check/check.h
  src/liblzma/check/crc32_table_be.h
  src/liblzma/check/crc32_table_le.h
  src/liblzma/check/crc64_table_be.h
  src/liblzma/check/crc64_table_le.h
  src/liblzma/check/crc_macros.h
  src/liblzma/common/alone_decoder.h
  src/liblzma/common/block_buffer_encoder.h
  src/liblzma/common/block_decoder.h
  src/liblzma/common/block_encoder.h
  src/liblzma/common/common.h
  src/liblzma/common/easy_preset.h
  src/liblzma/common/filter_common.h
  src/liblzma/common/filter_decoder.h
  src/liblzma/common/filter_encoder.h
  src/liblzma/common/index.h
  src/liblzma/common/index_encoder.h
  src/liblzma/common/memcmplen.h
  src/liblzma/common/outqueue.h
  src/liblzma/common/stream_decoder.h
  src/liblzma/common/stream_flags_common.h
  src/liblzma/delta/delta_common.h
  src/liblzma/delta/delta_decoder.h
  src/liblzma/delta/delta_encoder.h
  src/liblzma/delta/delta_private.h
  src/liblzma/lzma/fastpos.h
  src/liblzma/lzma/lzma2_decoder.h
  src/liblzma/lzma/lzma2_encoder.h
  src/liblzma/lzma/lzma_common.h
  src/liblzma/lzma/lzma_decoder.h
  src/liblzma/lzma/lzma_encoder.h
  src/liblzma/lzma/lzma_encoder_private.h
  src/liblzma/lz/lz_decoder.h
  src/liblzma/lz/lz_encoder.h
  src/liblzma/lz/lz_encoder_hash.h
  src/liblzma/lz/lz_encoder_hash_table.h
  src/liblzma/rangecoder/price.h
  src/liblzma/rangecoder/range_common.h
  src/liblzma/rangecoder/range_decoder.h
  src/liblzma/rangecoder/range_encoder.h
  src/liblzma/simple/simple_coder.h
  src/liblzma/simple/simple_decoder.h
  src/liblzma/simple/simple_encoder.h
  src/liblzma/simple/simple_private.h)

set(headers
  src/liblzma/api/lzma.h
  src/liblzma/api/lzma/base.h
  src/liblzma/api/lzma/bcj.h
  src/liblzma/api/lzma/block.h
  src/liblzma/api/lzma/check.h
  src/liblzma/api/lzma/container.h
  src/liblzma/api/lzma/delta.h
  src/liblzma/api/lzma/filter.h
  src/liblzma/api/lzma/hardware.h
  src/liblzma/api/lzma/index.h
  src/liblzma/api/lzma/index_hash.h
  src/liblzma/api/lzma/lzma12.h
  src/liblzma/api/lzma/stream_flags.h
  src/liblzma/api/lzma/version.h
  src/liblzma/api/lzma/vli.h
  src/liblzma/api/vtk_lzma_mangle.h)

vtk_module_add_module(VTK::lzma
  HEADER_DIRECTORIES
  SOURCES ${sources}
  HEADERS ${headers}
  PRIVATE_HEADERS ${private_headers}
  HEADERS_SUBDIR "vtklzma")
set_target_properties(lzma
  PROPERTIES
    C_STANDARD 99
    POSITION_INDEPENDENT_CODE 1)

if (BUILD_SHARED_LIBS)
  set_target_properties(lzma
    PROPERTIES
      DEFINE_SYMBOL DLL_EXPORT)
  if (CMAKE_USE_PTHREADS_INIT)
    target_link_libraries(lzma
      PRIVATE
        ${CMAKE_THREAD_LIBS_INIT})
  endif ()
endif ()

=== Examples/Plugins/Representation/Plugin/GeometryRepresentations/CMakeLists.txt ===
set(classes
  vtkMySpecialPolyDataMapper
  vtkOpenGLMySpecialPolyDataMapperDelegator
  vtkMySpecialRepresentation)

vtk_module_add_module(GeometryRepresentations
  FORCE_STATIC # Using FORCE_STATIC build the vtk module statically into the plugin library, to avoid confusion when loading
  CLASSES ${classes})

paraview_add_server_manager_xmls(
  XMLS  Representation.xml)

=== PKGBUILD ===
# Contributor: Mehdi Chinoune <mehdi.chinoune@hotmail.com>

_realname=paraview
pkgbase=mingw-w64-${_realname}
pkgname=("${MINGW_PACKAGE_PREFIX}-${_realname}")
pkgver=5.13.1
pkgrel=3
pkgdesc="Parallel Data Analysis and Visualization Application based on VTK. (mingw-w64)"
arch=('any')
mingw_arch=('mingw64' 'ucrt64' 'clang64' 'clangarm64')
url='https://www.paraview.org/'
msys2_repository_url="https://gitlab.kitware.com/paraview/paraview"
msys2_references=(
  'archlinux: paraview'
)
license=('spdx:BSD-3-Clause')
depends=("${MINGW_PACKAGE_PREFIX}-gcc-libs"
         "${MINGW_PACKAGE_PREFIX}-double-conversion"
         "${MINGW_PACKAGE_PREFIX}-cgns"
         "${MINGW_PACKAGE_PREFIX}-expat"
         "${MINGW_PACKAGE_PREFIX}-fmt"
         "${MINGW_PACKAGE_PREFIX}-gdal"
         "${MINGW_PACKAGE_PREFIX}-gl2ps"
         "${MINGW_PACKAGE_PREFIX}-glew"
         "${MINGW_PACKAGE_PREFIX}-hdf5"
         "${MINGW_PACKAGE_PREFIX}-jsoncpp"
         "${MINGW_PACKAGE_PREFIX}-libjpeg-turbo"
         "${MINGW_PACKAGE_PREFIX}-libogg"
         "${MINGW_PACKAGE_PREFIX}-liblas"
         "${MINGW_PACKAGE_PREFIX}-libpng"
         "${MINGW_PACKAGE_PREFIX}-libtheora"
         "${MINGW_PACKAGE_PREFIX}-libtiff"
         "${MINGW_PACKAGE_PREFIX}-libxml2"
         "${MINGW_PACKAGE_PREFIX}-lz4"
         "${MINGW_PACKAGE_PREFIX}-netcdf"
         "${MINGW_PACKAGE_PREFIX}-openturns"
         "${MINGW_PACKAGE_PREFIX}-pdal"
         #"${MINGW_PACKAGE_PREFIX}-pegtl" https://gitlab.kitware.com/vtk/vtk/-/issues/18151
         "${MINGW_PACKAGE_PREFIX}-protobuf"
         "${MINGW_PACKAGE_PREFIX}-python"
         "${MINGW_PACKAGE_PREFIX}-pugixml"
         "${MINGW_PACKAGE_PREFIX}-qt5-base"
         "${MINGW_PACKAGE_PREFIX}-qt5-svg"
         "${MINGW_PACKAGE_PREFIX}-qt5-tools"
         "${MINGW_PACKAGE_PREFIX}-tbb"
         $([[ ${MSYSTEM} == MINGW64 ]] || echo "${MINGW_PACKAGE_PREFIX}-verdict")
         "${MINGW_PACKAGE_PREFIX}-xz"
         "${MINGW_PACKAGE_PREFIX}-libwinpthread-git"
         "${MINGW_PACKAGE_PREFIX}-zlib")
makedepends=("${MINGW_PACKAGE_PREFIX}-cc"
             "${MINGW_PACKAGE_PREFIX}-cmake"
             "${MINGW_PACKAGE_PREFIX}-ninja"
             "${MINGW_PACKAGE_PREFIX}-qt5-xmlpatterns"
             "${MINGW_PACKAGE_PREFIX}-python-numpy"
             "${MINGW_PACKAGE_PREFIX}-cli11"
             "${MINGW_PACKAGE_PREFIX}-eigen3"
             "${MINGW_PACKAGE_PREFIX}-fast_float"
             "${MINGW_PACKAGE_PREFIX}-libharu"
             "${MINGW_PACKAGE_PREFIX}-nlohmann-json"
             "${MINGW_PACKAGE_PREFIX}-utf8cpp")
optdepends=("${MINGW_PACKAGE_PREFIX}-python-numpy"
            "${MINGW_PACKAGE_PREFIX}-python-matplotlib")
source=("https://www.paraview.org/files/v${pkgver%.*}/ParaView-v${pkgver}.tar.xz"
        "001-dll-export-some-vtk-functions.patch"
        "002-no-exact-version-for-fast_float.patch"
        "003-CellAttribute-Fix-mingw-build.patch::https://gitlab.kitware.com/vtk/vtk/-/commit/5a7de249.patch"
        "004-fix-build-with-fmt-11.patch"
        "005-avoid-file-conflict-with-vtk.patch")
sha256sums=('a16503ce37b999c2967d84234596e7bf67ac98221851a288bb1399c7e1dc2004'
            'a9b9292be90c259f0aa058e3f4a7a08b6218f20e6cb2a71e214acda2d2302a50'
            '411b0521fcd2864acae0af20ba6334f69f7c605c9e31996529f64aa749d61065'
            '784d9345ebb1a83841970df34d743344189604457270df0f594669639a718ec8'
            'c92343b01c50a93805c7068058416cf010cceba6700e4cc16b3be98598d2295f'
            '374c7fbca1d225fdb7eafd646937c202cb0427acd1558f2d8411ab0c394d6287')

apply_patch_with_msg() {
  for _patch in "$@"
  do
    msg2 "Applying ${_patch}"
    patch -Nbp1 -i "${srcdir}/${_patch}"
  done
}

prepare() {
  cd "${srcdir}"/ParaView-v${pkgver}

  cd VTK
  if [[ ${MINGW_PACKAGE_PREFIX} == *-clang-* ]]; then
    # Copied from mingw-w64-vtk/007-dll-export-some-functions.patch
    apply_patch_with_msg \
      001-dll-export-some-vtk-functions.patch
  fi

  apply_patch_with_msg \
    002-no-exact-version-for-fast_float.patch \
    003-CellAttribute-Fix-mingw-build.patch \
    004-fix-build-with-fmt-11.patch \
    005-avoid-file-conflict-with-vtk.patch
}

build() {
  mkdir -p "${srcdir}/build-${MSYSTEM}" && cd "${srcdir}/build-${MSYSTEM}"

  declare -a _extra_config
  if check_option "debug" "n"; then
    _extra_config+=("-DCMAKE_BUILD_TYPE=Release")
  else
    _extra_config+=("-DCMAKE_BUILD_TYPE=Debug")
  fi

  if [[ ${MSYSTEM} == MINGW64 ]]; then
    _extra_config+=("-DVTK_MODULE_USE_EXTERNAL_VTK_verdict=OFF")
  fi

  _pyver=$(${MINGW_PREFIX}/bin/python -c "import sys; print(f'{sys.version_info.major}.{sys.version_info.minor}')")

  CXXFLAGS+=" -w -Wno-register" \
  MSYS2_ARG_CONV_EXCL="-DCMAKE_INSTALL_PREFIX=" \
    "${MINGW_PREFIX}"/bin/cmake.exe -Wno-dev \
      -GNinja \
      -DCMAKE_INSTALL_PREFIX="${MINGW_PREFIX}" \
      "${_extra_config[@]}" \
      -DPARAVIEW_BUILD_SHARED_LIBS=ON \
      -DPARAVIEW_USE_PYTHON=ON \
      -DPARAVIEW_USE_QT=ON \
      -DPARAVIEW_USE_MPI=OFF \
      -DPARAVIEW_ENABLE_GDAL=ON \
      -DPARAVIEW_ENABLE_LAS=ON \
      -DPARAVIEW_ENABLE_OPENTURNS=ON \
      -DPARAVIEW_ENABLE_PDAL=ON \
      -DPARAVIEW_VERSIONED_INSTALL=OFF \
      -DPARAVIEW_CUSTOM_LIBRARY_SUFFIX="pv${pkgver%.*}" \
      -DPARAVIEW_BUILD_WITH_EXTERNAL=ON \
      -DPARAVIEW_PYTHON_SITE_PACKAGES_SUFFIX="lib/python${_pyver}/site-packages/pv/" \
      -DPARAVIEW_IGNORE_CMAKE_CXX11_CHECKS=ON \
      -DVTK_SMP_IMPLEMENTATION_TYPE=TBB \
      -DVTK_MODULE_USE_EXTERNAL_VTK_exprtk=OFF \
      -DVTK_MODULE_USE_EXTERNAL_VTK_ioss=OFF \
      -DVTK_MODULE_USE_EXTERNAL_VTK_pegtl=OFF \
      -DVTK_MODULE_USE_EXTERNAL_VTK_token=OFF \
      -DPython3_EXECUTABLE=${MINGW_PREFIX}/bin/python.exe \
      ../ParaView-v${pkgver}

  "${MINGW_PREFIX}"/bin/cmake.exe --build .
}

package() {
  cd "${srcdir}/build-${MSYSTEM}"

  DESTDIR="${pkgdir}" "${MINGW_PREFIX}"/bin/cmake.exe --install .

  MSYS2_ARG_CONV_EXCL="-p" python -m compileall \
    -o 0 -o 1 -q -s"${pkgdir}" -p"/" "${pkgdir}${MINGW_PREFIX}/lib/python"*

  install -Dm644 "${srcdir}/ParaView-v${pkgver}/Copyright.txt" "${pkgdir}${MINGW_PREFIX}/share/licenses/${_realname}/LICENSE"
}
